typedef struct rgba {
   float r;
   float g;
   float b;
   float a;
} rgba_t;

void AoS( rgba_t* src_image1, rgba_t* src_image2, rgba_t* dst_image) {
#pragma ivdep
   for (int i = 0; i < 1024; i++)
   {
      dst_image[i].r = 0.5 * (src_image1[i].r + src_image2[i].r);
      dst_image[i].g = 0.5 * (src_image1[i].g + src_image2[i].g);
      dst_image[i].b = 0.5 * (src_image1[i].b + src_image2[i].b);
      dst_image[i].a = 0.5 * (src_image1[i].a + src_image2[i].a);
   }
}



typedef struct rgba_soa {
   float *r;
   float *g;
   float *b;
   float *a;
} rgba_soa_t;


void SoA( rgba_soa_t src_image1, rgba_soa_t src_image2, rgba_soa_t dst_image) {
#pragma ivdep
   for (int i = 0; i < 1024; i++)
   {
      dst_image.r[i] = 0.5 * (src_image1.r[i] + src_image2.r[i]);
      dst_image.g[i] = 0.5 * (src_image1.g[i] + src_image2.g[i]);
      dst_image.b[i] = 0.5 * (src_image1.b[i] + src_image2.b[i]);
      dst_image.a[i] = 0.5 * (src_image1.a[i] + src_image2.a[i]);
   }
}
